angular.module('starter.controllers', [])

.controller('AppCtrl', function($scope, $ionicModal, $timeout) {
  // Form data for the login modal
  $scope.loginData = {};

  // Create the login modal that we will use later
  $ionicModal.fromTemplateUrl('templates/login.html', {
    scope: $scope
  }).then(function(modal) {
    $scope.modal = modal;
  });

  // Triggered in the login modal to close it
  $scope.closeLogin = function() {
    $scope.modal.hide();
  };

  // Open the login modal
  $scope.login = function() {
    $scope.modal.show();
  };

  // Perform the login action when the user submits the login form
  $scope.doLogin = function() {
    console.log('Doing login', $scope.loginData);

    // Simulate a login delay. Remove this and replace with your login
    // code if using a login system
    $timeout(function() {
      $scope.closeLogin();
    }, 1000);
  };
})

.controller('PlaylistsCtrl', function($scope) {
  $scope.playlists = [
    { title: 'Reggae', id: 1 },
    { title: 'Chill', id: 2 },
    { title: 'Dubstep', id: 3 },
    { title: 'Indie', id: 4 },
    { title: 'Rap', id: 5 },
    { title: 'Cowbell', id: 6 }
  ];
})

.controller('PlaylistCtrl', function($scope, $stateParams) {
})


.controller("MainCtrl", ['$scope', 'ContactsService', function($scope, ContactsService) {

  $scope.data = {
    selectedContact : []
  };

  $scope.directsendtoggle = true;

  $scope.pickContact = function() {

    ContactsService.pickContact().then(
        function(contact) {
          $scope.data.selectedContact = [];
          $scope.data.selectedContact.push(contact);
          console.log("Selected contacts=");
          console.log($scope.data.selectedContact);
          $scope.directsendtoggle = false;
        },
        function(failure) {
          console.log("Bummer.  Failed to pick a contact" + failure);
          $scope.directsendtoggle = true;
        }
    );

  }

}])


.controller('SheetCtrl', function($scope, $ionicActionSheet, $timeout) {

  function base64Encode ($nr) {
    // Create Base64 Object
    var Base64={_keyStr:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",encode:function(e){var t="";var n,r,i,s,o,u,a;var f=0;e=Base64._utf8_encode(e);while(f<e.length){n=e.charCodeAt(f++);r=e.charCodeAt(f++);i=e.charCodeAt(f++);s=n>>2;o=(n&3)<<4|r>>4;u=(r&15)<<2|i>>6;a=i&63;if(isNaN(r)){u=a=64}else if(isNaN(i)){a=64}t=t+this._keyStr.charAt(s)+this._keyStr.charAt(o)+this._keyStr.charAt(u)+this._keyStr.charAt(a)}return t},decode:function(e){var t="";var n,r,i;var s,o,u,a;var f=0;e=e.replace(/[^A-Za-z0-9\+\/\=]/g,"");while(f<e.length){s=this._keyStr.indexOf(e.charAt(f++));o=this._keyStr.indexOf(e.charAt(f++));u=this._keyStr.indexOf(e.charAt(f++));a=this._keyStr.indexOf(e.charAt(f++));n=s<<2|o>>4;r=(o&15)<<4|u>>2;i=(u&3)<<6|a;t=t+String.fromCharCode(n);if(u!=64){t=t+String.fromCharCode(r)}if(a!=64){t=t+String.fromCharCode(i)}}t=Base64._utf8_decode(t);return t},_utf8_encode:function(e){e=e.replace(/\r\n/g,"\n");var t="";for(var n=0;n<e.length;n++){var r=e.charCodeAt(n);if(r<128){t+=String.fromCharCode(r)}else if(r>127&&r<2048){t+=String.fromCharCode(r>>6|192);t+=String.fromCharCode(r&63|128)}else{t+=String.fromCharCode(r>>12|224);t+=String.fromCharCode(r>>6&63|128);t+=String.fromCharCode(r&63|128)}}return t},_utf8_decode:function(e){var t="";var n=0;var r=c1=c2=0;while(n<e.length){r=e.charCodeAt(n);if(r<128){t+=String.fromCharCode(r);n++}else if(r>191&&r<224){c2=e.charCodeAt(n+1);t+=String.fromCharCode((r&31)<<6|c2&63);n+=2}else{c2=e.charCodeAt(n+1);c3=e.charCodeAt(n+2);t+=String.fromCharCode((r&15)<<12|(c2&63)<<6|c3&63);n+=3}}return t}}

    // Define the string
    var string = $nr;

    // Encode the String
    var encodedString = Base64.encode(string);

    return encodedString;
  }

  // Triggered on a button click, or some other target
  $scope.showActionMenu = function($number) {

    var urlSafeBase64EncodedFinalString = base64Encode ( $number);
    if($number !== ''){
      var num_prefix = ' an ';
    }
    else
    {
      var num_prefix = '';
    }

    // Show the action sheet
    var hideSheet = $ionicActionSheet.show({
      buttons: [
        { text: '<b>SMS' + num_prefix + $number + ' verfassen</b>' }
      ],
      //destructiveText: 'Delete',
      titleText: 'Jetzt SMS versenden',
      cancelText: 'Abbrechen',
      cancel: function() {
        // add cancel code..
      },
      buttonClicked: function(index) {
        var deviceID = device.uuid;

        var ext_prop  = '';

        if(urlSafeBase64EncodedFinalString !== '') {
          ext_prop = 'prop='+urlSafeBase64EncodedFinalString;
        }

        if(deviceID !== '') {
          ext_prop = ext_prop + '&id='+deviceID;
        }

        if(ext_prop !== '') {
          ext_prop = '?' + ext_prop;
        }

        var inAppBrowserbRef;
        inAppBrowserbRef = window.open('http://www.sms-gruesse.de/v/0.8.1.php' + ext_prop, '_blank', 'location=no,toolbar=no,clearcache=yes,clearsessioncache=yes');
        inAppBrowserbRef.addEventListener('loadstart', inAppBrowserbLoadStart);
        inAppBrowserbRef.addEventListener('loadstop', inAppBrowserbLoadStop);
        inAppBrowserbRef.addEventListener('loaderror', inAppBrowserbLoadError);
        inAppBrowserbRef.addEventListener('exit', inAppBrowserbClose);
        function inAppBrowserbLoadStart(event) {
          navigator.notification.activityStart("Bitte warten", "Daten werden geladen....");
          //alert(event.type + ' - ' + event.url);
        }

        function inAppBrowserbLoadStop(event) {
          navigator.notification.activityStop();
          //alert(event.type + ' - ' + event.url);
        }

        function inAppBrowserbLoadError(event) {
          navigator.notification.activityStop();
          //alert(event.type + ' - ' + event.message);
        }

        function inAppBrowserbClose(event) {
          //navigator.notification.activityStop();
          //alert(event.type);
          inAppBrowserbRef.removeEventListener('loadstart', inAppBrowserbLoadStart);
          inAppBrowserbRef.removeEventListener('loadstop', inAppBrowserbLoadStop);
          inAppBrowserbRef.removeEventListener('loaderror', inAppBrowserbLoadError);
          inAppBrowserbRef.removeEventListener('exit', inAppBrowserbClose);
        }
        return true;
      }
    });

    // For example's sake, hide the sheet after eight seconds
    $timeout(function() {
      hideSheet();
    }, 8000);

  };
});
